#!/usr/bin/perl
#
# lt24merge.pl - Merge LED Toy firmware with images
#
# Written 2005 by Werner Almesberger
# Copyright 2005 by Werner Almesberger
#

$MAX_BYTES = (4096-0x100)*2;

$fw = shift(@ARGV);
if (!defined $fw) {
    print STDERR "usage: $ARGV[0] firmware.bin [image.xbm ...]\n";
    exit(1);
}

open(FILE,$fw) || die "$fw: $!";
while (<FILE>) {
    $bin .= $_;
}
close FILE;

$bin .= pack("c2",0+@ARGV,0x34);

for (@ARGV) {
    ($name = $_) =~ s/\.xbm$//;
    @args = ("cc","-o","image.bin","-DINCLUDE_NAME=\"$_\"","-DNAME=$name",
      "bitmap2asm.c");
    system(@args) == 0 || die "system @args failed: $?";
    $bin .= `./image.bin -b`;
}
unlink("image.bin");

$len = length($bin);
if ($len > $MAX_BYTES) {
    print STDERR "output is too big ($len > $MAX_BYTES)\n";
    exit(1);
}

print $bin;
